//  Copyright 2008 Actel Corporation.  All rights reserved.
// ANY USE OR REDISTRIBUTION IN PART OR IN WHOLE MUST BE HANDLED IN
// ACCORDANCE WITH THE ACTEL LICENSE AGREEMENT AND MUST BE APPROVED
//  Revision Information:
// Jun09    Revision 4.1
// SVN Revision Information:
// SVN $Revision: 8508 $
`timescale 1ns/1ns
module
COREUART
(
RESET_N
,
CLK
,
WEN
,
OEN
,
CSN
,
DATA_IN
,
RX
,
BAUD_VAL
,
BIT8
,
PARITY_EN
,
ODD_N_EVEN
,
PARITY_ERR
,
OVERFLOW
,
TXRDY
,
RXRDY
,
DATA_OUT
,
TX
,
FRAMING_ERR
)
;
parameter
TX_FIFO
=
0
;
parameter
RX_FIFO
=
0
;
parameter
RX_LEGACY_MODE
=
0
;
parameter
FAMILY
=
15
;
input
RESET_N
;
input
CLK
;
input
WEN
;
input
OEN
;
input
CSN
;
input
[
7
:
0
]
DATA_IN
;
input
RX
;
input
[
12
:
0
]
BAUD_VAL
;
input
BIT8
;
input
PARITY_EN
;
input
ODD_N_EVEN
;
output
PARITY_ERR
;
output
OVERFLOW
;
output
TXRDY
;
output
RXRDY
;
output
[
7
:
0
]
DATA_OUT
;
output
TX
;
output
FRAMING_ERR
;
`define S0  \
2 \
'b \
00
`define S1  \
2 \
'b \
01
`define CUARTIOI  \
2 \
'b \
10
`define CUARTlOI  \
2 \
'b \
11
wire
PARITY_ERR
;
wire
FRAMING_ERR
;
wire
OVERFLOW
;
wire
CUARTOII
;
wire
TXRDY
;
reg
RXRDY
;
wire
CUARTIII
;
wire
CUARTlII
;
wire
CUARTOlI
;
reg
[
7
:
0
]
DATA_OUT
;
wire
TX
;
wire
CUARTO0
;
wire
CUARTll
;
wire
CUARTIlI
;
reg
[
7
:
0
]
CUARTllI
;
wire
[
7
:
0
]
CUARTO0I
;
wire
[
7
:
0
]
CUARTI0I
;
wire
CUARTl0I
;
reg
[
7
:
0
]
CUARTO1I
;
wire
[
7
:
0
]
CUARTI1I
;
wire
[
7
:
0
]
CUARTl1I
;
wire
CUARTOOl
;
wire
CUARTIOl
;
reg
CUARTlOl
;
reg
CUARTOIl
;
wire
CUARTIIl
;
wire
CUARTlIl
;
wire
CUARTOll
;
wire
CUARTIll
;
wire
CUARTlll
;
wire
CUARTO0l
;
reg
CUARTI0l
;
reg
CUARTl0l
;
wire
CUARTO1l
;
reg
CUARTI1l
;
reg
CUARTl1l
;
reg
CUARTOO0
;
reg
CUARTIO0
;
reg
CUARTlO0
;
reg
CUARTOI0
;
reg
[
1
:
0
]
CUARTII0
;
reg
[
1
:
0
]
CUARTlI0
;
wire
CUARTOl0
;
wire
CUARTIl0
;
reg
CUARTll0
;
wire
CUARTO00
;
always
@
(
posedge
CLK
or
negedge
RESET_N
)
begin
:
CUARTI00
if
(
RESET_N
==
1
'b
0
)
begin
CUARTllI
<=
{
8
{
1
'b
0
}
}
;
CUARTOIl
<=
1
'b
1
;
end
else
begin
CUARTOIl
<=
1
'b
1
;
if
(
CSN
==
1
'b
0
&
WEN
==
1
'b
0
)
begin
CUARTllI
<=
DATA_IN
;
CUARTOIl
<=
1
'b
0
;
end
end
end
assign
CUARTIlI
=
WEN
==
1
'b
0
&
CSN
==
1
'b
0
?
1
'b
1
:
1
'b
0
;
always
@
(
CUARTI1I
or
CUARTO1I
or
PARITY_ERR
)
begin
if
(
RX_FIFO
==
1
'b
0
)
begin
DATA_OUT
=
CUARTI1I
;
end
else
begin
if
(
PARITY_ERR
==
1
'b
1
)
begin
DATA_OUT
=
CUARTI1I
;
end
else
begin
DATA_OUT
=
CUARTO1I
;
end
end
end
assign
CUARTl0I
=
(
RX_FIFO
==
1
'b
0
)
?
(
(
CSN
==
1
'b
0
&
OEN
==
1
'b
0
)
?
1
'b
1
:
1
'b
0
)
:
!
CUARTOll
;
assign
CUARTIll
=
(
RX_FIFO
==
1
'b
0
)
?
(
(
CSN
==
1
'b
0
&
OEN
==
1
'b
0
)
?
1
'b
1
:
1
'b
0
)
:
CUARTl0l
;
assign
CUARTlll
=
(
RX_FIFO
==
1
'b
0
)
?
(
(
CSN
==
1
'b
0
&
OEN
==
1
'b
0
)
?
1
'b
1
:
1
'b
0
)
:
CUARTl1l
;
assign
CUARTO00
=
(
CSN
==
1
'b
0
&
OEN
==
1
'b
0
)
?
1
'b
1
:
1
'b
0
;
assign
CUARTl1I
=
(
PARITY_ERR
==
1
'b
0
)
?
CUARTI1I
:
8
'b
0
;
generate
if
(
RX_LEGACY_MODE
==
1
'b
1
)
begin
always
@
(
CUARTIII
or
CUARTlO0
)
begin
if
(
RX_FIFO
==
1
'b
0
)
begin
RXRDY
=
CUARTIII
;
end
else
begin
RXRDY
=
!
CUARTlO0
;
end
end
end
else
begin
always
@
(
posedge
CLK
or
negedge
RESET_N
)
begin
if
(
RESET_N
==
1
'b
0
)
begin
RXRDY
=
1
'b
0
;
end
else
begin
if
(
RX_FIFO
==
1
'b
0
)
begin
if
(
CUARTOl0
==
1
'b
1
||
CUARTIII
==
1
'b
0
)
begin
RXRDY
=
CUARTIII
;
end
end
else
begin
if
(
CUARTOl0
==
1
'b
1
||
(
CUARTlO0
==
1
'b
1
)
||
(
(
CUARTlO0
==
1
'b
0
)
&&
(
CUARTIl0
==
1
'b
1
)
)
)
begin
RXRDY
=
!
CUARTlO0
;
end
end
end
end
end
endgenerate
always
@
(
posedge
CLK
or
negedge
RESET_N
)
begin
if
(
RESET_N
==
1
'b
0
)
begin
CUARTl0l
<=
1
'b
0
;
CUARTI0l
<=
1
'b
0
;
end
else
begin
CUARTI0l
<=
CUARTO0l
;
CUARTl0l
<=
CUARTI0l
;
end
end
always
@
(
posedge
CLK
or
negedge
RESET_N
)
begin
if
(
RESET_N
==
1
'b
0
)
begin
CUARTl1l
<=
1
'b
0
;
CUARTI1l
<=
1
'b
0
;
end
else
begin
CUARTI1l
<=
CUARTO1l
;
CUARTl1l
<=
CUARTI1l
;
end
end
always
@
(
posedge
CLK
or
negedge
RESET_N
)
begin
if
(
RESET_N
==
1
'b
0
)
begin
CUARTII0
<=
`S0
;
end
else
begin
CUARTII0
<=
CUARTlI0
;
end
end
always
@
(
CUARTII0
,
CUARTlO0
,
CUARTIOl
)
begin
CUARTlI0
=
CUARTII0
;
CUARTlOl
=
1
'b
1
;
CUARTOO0
=
1
'b
0
;
case
(
CUARTII0
)
`S0
:
if
(
CUARTlO0
==
1
'b
1
&&
CUARTIOl
==
1
'b
0
)
begin
CUARTlI0
=
`S1
;
CUARTlOl
=
1
'b
0
;
end
`S1
:
CUARTlI0
=
`CUARTIOI
;
`CUARTIOI
:
CUARTlI0
=
`CUARTlOI
;
`CUARTlOI
:
begin
CUARTlI0
=
`S0
;
CUARTOO0
=
1
'b
1
;
end
endcase
end
always
@
(
posedge
CLK
or
negedge
RESET_N
)
begin
if
(
RESET_N
==
1
'b
0
)
begin
CUARTO1I
<=
{
8
{
1
'b
0
}
}
;
end
else
begin
if
(
CUARTOO0
==
1
'b
1
)
begin
CUARTO1I
<=
CUARTI0I
;
end
end
end
always
@
(
posedge
CLK
or
negedge
RESET_N
)
begin
if
(
RESET_N
==
1
'b
0
)
begin
CUARTlO0
<=
1
'b
1
;
CUARTOI0
<=
1
'b
1
;
end
else
begin
if
(
CUARTOO0
==
1
'b
1
)
begin
CUARTlO0
<=
1
'b
0
;
end
else
begin
if
(
CSN
==
1
'b
0
&&
OEN
==
1
'b
0
)
begin
CUARTlO0
<=
1
'b
1
;
end
end
CUARTOI0
<=
CUARTlO0
;
end
end
always
@
(
posedge
CLK
or
negedge
RESET_N
)
begin
if
(
RESET_N
==
1
'b
0
)
begin
CUARTll0
<=
1
'b
0
;
end
else
begin
if
(
CUARTOlI
==
1
'b
0
&&
CUARTOll
==
1
'b
1
)
CUARTll0
<=
1
'b
1
;
else
if
(
CUARTO00
==
1
'b
1
)
CUARTll0
<=
1
'b
0
;
else
CUARTll0
<=
CUARTll0
;
end
end
assign
OVERFLOW
=
(
RX_FIFO
==
1
'b
0
)
?
CUARTOII
:
CUARTll0
;
assign
CUARTlII
=
(
(
PARITY_ERR
==
1
'b
1
)
||
CUARTOll
==
1
'b
1
)
?
1
'b
1
:
CUARTOlI
;
CUARTII
CUARTl00
(
.CUARTlI
(
CLK
)
,
.CUARTOl
(
RESET_N
)
,
.CUARTIl
(
BAUD_VAL
)
,
.CUARTll
(
CUARTll
)
,
.CUARTO0
(
CUARTO0
)
)
;
CUARTO10
#
(
.TX_FIFO
(
TX_FIFO
)
)
CUARTI10
(
.CUARTlI
(
CLK
)
,
.CUARTO0
(
CUARTO0
)
,
.CUARTOl
(
RESET_N
)
,
.CUARTIlI
(
CUARTIlI
)
,
.CUARTllI
(
CUARTllI
)
,
.CUARTO0I
(
CUARTO0I
)
,
.CUARTl10
(
CUARTOOl
)
,
.CUARTOO1
(
CUARTlIl
)
,
.CUARTIO1
(
BIT8
)
,
.CUARTlO1
(
PARITY_EN
)
,
.CUARTOI1
(
ODD_N_EVEN
)
,
.CUARTII1
(
TXRDY
)
,
.CUARTlI1
(
TX
)
,
.CUARTIIl
(
CUARTIIl
)
)
;
CUARTOl1
#
(
.RX_FIFO
(
RX_FIFO
)
,
.RX_LEGACY_MODE
(
RX_LEGACY_MODE
)
)
CUARTIl1
(
.CUARTlI
(
CLK
)
,
.CUARTll
(
CUARTll
)
,
.CUARTOl
(
RESET_N
)
,
.CUARTIO1
(
BIT8
)
,
.CUARTlO1
(
PARITY_EN
)
,
.CUARTOI1
(
ODD_N_EVEN
)
,
.CUARTl0I
(
CUARTl0I
)
,
.CUARTIll
(
CUARTIll
)
,
.CUARTll1
(
FRAMING_ERR
)
,
.CUARTlll
(
CUARTlll
)
,
.CUARTOl0
(
CUARTOl0
)
,
.CUARTIl0
(
CUARTIl0
)
,
.CUARTO01
(
RX
)
,
.CUARTI01
(
CUARTOII
)
,
.CUARTl01
(
PARITY_ERR
)
,
.CUARTO0l
(
CUARTO0l
)
,
.CUARTO1l
(
CUARTO1l
)
,
.CUARTIII
(
CUARTIII
)
,
.CUARTI1I
(
CUARTI1I
)
,
.CUARTOlI
(
CUARTOlI
)
)
;
generate
if
(
TX_FIFO
==
1
'b
1
)
begin
CUARTO11
CUARTI11
(
.CUARTl11
(
CUARTO0I
)
,
.CUARTOOOI
(
CLK
)
,
.CUARTIOOI
(
CLK
)
,
.CUARTlOOI
(
CUARTllI
)
,
.WRB
(
CUARTOIl
)
,
.RDB
(
CUARTIIl
)
,
.RESET
(
RESET_N
)
,
.FULL
(
CUARTlIl
)
,
.EMPTY
(
CUARTOOl
)
)
;
end
endgenerate
generate
if
(
RX_FIFO
==
1
'b
1
)
begin
CUARTO11
CUARTOIOI
(
.CUARTl11
(
CUARTI0I
)
,
.CUARTOOOI
(
CLK
)
,
.CUARTIOOI
(
CLK
)
,
.CUARTlOOI
(
CUARTl1I
)
,
.WRB
(
CUARTlII
)
,
.RDB
(
CUARTlOl
)
,
.RESET
(
RESET_N
)
,
.FULL
(
CUARTOll
)
,
.EMPTY
(
CUARTIOl
)
)
;
end
endgenerate
endmodule
